Global("texts", { })
Global("L", { })

-- AO game Localization detection by SLA. Version 2011-02-10.
function GetGameLocalization()
 local B = cartographer.GetMapBlocks()
 local T = { rus="\203\232\227\224", 
             eng="Holy Land", 
             ger="Heiliges Land",
             fra="Terre Sacr\233e", 
             br ="Terra Sagrada", 
             jpn="\131\74\131\106\131\65" }
 for b in B do 
   for l,t in T do
     if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t then
       return l 
     end
   end
 end
 return "eng"
end

function GetTextLocalized(strTextName, language)
  local textgroup = common.GetAddonRelatedTextGroup(language)
  if textgroup then
    return textgroup:GetText(strTextName)
  end
  return common.GetEmptyWString()
end

-- Load all localized texts
-- Load texts for language eng
texts["eng"] = { }
texts["eng"]["sample"] = GetTextLocalized("sample", "eng")

-- Initial all registered textelements
function UpdateLocalization()
  View.Sample.widget:SetVal("text", L["sample"])
end
-- Set L to English, because in AO 2.0.03 was the GetGameLocalization broken
-- and L was nil. I used the second timer and every second occur an error.
L = texts["eng"]
-- Set current GameLocalization to L
CallWhenCharacterAvailable(function()
  L = texts[GetGameLocalization()] or L
  UpdateLocalization()
end)

