--------------------------------------------------------------------------------
--- Locals
--------------------------------------------------------------------------------
local widget = { }
local wtPanel = View.Point
local wtControl3D = nil
local backgroundColor = {r = 1.0; g = 1.0; b = 1.0; a = 0.0 }
Global("panelwidth", _G["3DWidgetWidth"])
Global("panelheight", _G["3DWidgetHeight"] / 2)
--------------------------------------------------------------------------------
--- Functions
--------------------------------------------------------------------------------
function Create3DWidget(unitId)
  local w = mainForm:CreateWidgetByDesc(wtPanel.widget:GetWidgetDesc())
  local placementPlain = w:GetPlacementPlain()
  placementPlain.sizeX = panelwidth
  placementPlain.sizeY = panelheight
  w:SetPlacementPlain(placementPlain)
  w:SetBackgroundColor(backgroundColor)
  widget[unitId] = w
  return w
end

function Place3DWidget(unitId, widget)
  local pos = avatar.GetPos()
  wtControl3D:AddWidget3D(widget, { sizeX = panelwidth, sizeY = panelheight }, pos, true, false, 100.0, WIDGET_3D_BIND_POINT_CENTER, 0.1, 0.4)
  object.AttachWidget3D(unitId, wtControl3D, widget, -1)
  widget:Show(true)
end

function Remove3DWidget(unitId)
  local w = widget[unitId]
  if w then
    widget[unitId] = nil
	object.DetachWidget3D(unitId, w)
	w:Show(false)
	w:DestroyWidget()
  end
end

function Get3DWidget(unitId)
  if widget[unitId] then
    return widget[unitId]
  end
  local w = Create3DWidget(unitId)
  Place3DWidget(unitId, w)
  return w
end

--------------------------------------------------------------------------------
--- EVENTS
--------------------------------------------------------------------------------
onEvent["EVENT_UNIT_DESPAWNED"] = function(params)
  Remove3DWidget(params.unitId)
end
--------------------------------------------------------------------------------
--- REACTIONS
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--- INITIALIZATION
--------------------------------------------------------------------------------
CallWhenCharacterAvailable(function()
  wtControl3D = stateMainForm:GetChildChecked("MainAddonMainForm", true):GetChildChecked("MainScreenControl3D", false)
  
  wtPanel:setSize(panelwidth, panelheight)
  wtPanel.widget:SetBackgroundColor({r = 1.0; g = 1.0; b = 1.0; a = 0.0 })
  
end)