--------------------------------------------------------------------------------
--- Locals
--------------------------------------------------------------------------------
local wtSample = View.Sample
wtSample.widget:Show(false)

local texts = { }
local freetexts = { }
local widgets = { } 
--------------------------------------------------------------------------------
--- Functions
--------------------------------------------------------------------------------
function GetTextFormatDamage(subElement, isCritical, isGlancing)
  
  if subElement == "ENUM_SubElement_PHYSICAL" then
	if isCritical then
	  return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\" outlinecolor=\"0xFF000000\" outline=\"150\"><rs class=\"CLASS\"><tip_red><r name=\"text\"/></tip_red></rs></body>"))
	elseif isGlancing then
	  return (userMods.ToWString("<body color=\"0x7FFFFFFF\" alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\" outlinecolor=\"0xFF000000\" outline=\"1\"><rs class=\"CLASS\"><r name=\"text\"/></rs></body>"))
	else
	  return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\"><rs class=\"CLASS\"><tip_white><r name=\"text\"/></tip_white></rs></body>"))
	end
  else
	if isCritical then
	  return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\" outlinecolor=\"0xFF000000\" outline=\"150\"><rs class=\"CLASS\"><LogColorOrange><r name=\"text\"/></LogColorOrange></rs></body>"))
	elseif isGlancing then
	  return (userMods.ToWString("<body color=\"0x7F00FFFF\" alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\" outlinecolor=\"0xFF000000\" outline=\"1\"><rs class=\"CLASS\"><r name=\"text\"/></rs></body>"))
	else
	  return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\"><rs class=\"CLASS\"><tip_golden><r name=\"text\"/></tip_golden></rs></body>"))
	end
  end
end

function GetTextFormatHeal(isCritical)
  if isCritical then
	return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\" outlinecolor=\"0xFF000000\" outline=\"150\"><rs class=\"CLASS\"><LogColorLightGreen><r name=\"text\"/></LogColorLightGreen></rs></body>"))
  else
	return (userMods.ToWString("<body alignx=\"center\" aligny=\"center\" shadow=\"1\" fontsize=\"40\"><rs class=\"CLASS\"><LogColorGreen><r name=\"text\"/></LogColorGreen></rs></body>"))
  end
end

function GetTextScale(number)
  number = number or 0
  local level = unit.GetLevel(avatar.GetId())
  local result = 46 / level
  local increasement = 2 / level
  while number > 2 do
    result = result + increasement
	increasement = increasement + (2 / level)
	number = number / 2
  end
  return result
end

function CreateText()
  local text = mainForm:CreateWidgetByDesc(wtSample.widget:GetWidgetDesc())
  widgets[common.RequestIntegerByInstanceId(text:GetInstanceId())] = text
  texts[text] = true
  text:Show(true)
  return text
end

function GetFreeText()  
  for k, v in freetexts do
    freetexts[k] = nil
	texts[k] = true
	k:Show(true)
	return k
  end
  return CreateText()
end

function FreeText(text)
  text = widgets[common.RequestIntegerByInstanceId(text:GetInstanceId())]
  if texts[text] then
    texts[text] = nil
	freetexts[text] = true
	text:Show(false)
  end
end

function GetTextByKey(element)
  if element then
    local instanceId = common.RequestIntegerByInstanceId(element:GetInstanceId())
    element = widgets[instanceId]  
    if element then
      return texts[element]
    end
  end
  return nil
end