--------------------------------------------------------------------------------
--- Locals
--------------------------------------------------------------------------------
local wtPanel = View.Point
local textures = { }
local freetextures = { }
local widgets = { }
--------------------------------------------------------------------------------
--- Functions
--------------------------------------------------------------------------------
function CreateTexture(textureId)
  local texture = mainForm:CreateWidgetByDesc(wtPanel.widget:GetWidgetDesc())
  widgets[common.RequestIntegerByInstanceId(texture:GetInstanceId())] = texture
  textures[texture] = true
  texture:Show(true)
  texture:SetBackgroundTexture(textureId)
  return texture
end

function GetFreeTexture(textureId)
  for k, v in freetextures do
    freetextures[k] = nil
	textures[k] = true
	k:Show(true)
	k:SetBackgroundTexture(textureId)
	return k
  end
  return CreateTexture(textureId)
end

function FreeTexture(texture)
  texture = widgets[common.RequestIntegerByInstanceId(texture:GetInstanceId())]
  if textures[texture] then
    textures[texture] = nil
	freetextures[texture] = true
	texture:Show(false)
  end
end

function GetTexture(params)
  if params then
    if params.spellId then
	  local spellInfo = avatar.GetSpellInfo( params.spellId )
	  return spellInfo.texture
	elseif params.abilityId then
	  local abilityInfo = avatar.GetAbilityInfo( params.abilityId )
	  return abilityInfo.texture
	elseif params.buffId then
	  local buffInfo = avatar.GetBuffInfoById( params.buffId )
	  return GetBuffTexture(buffInfo.name)
	end
  end
  return nil
end

function GetTextureByKey(element)
  if element then
    local instanceId = common.RequestIntegerByInstanceId(element:GetInstanceId())  
    element = widgets[instanceId]  
    if element then
      return textures[element]
    end
  end
  return nil
end