--------------------------------------------------------------------------------
--- Locals
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
--- Functions
--------------------------------------------------------------------------------
function GetDuration(number)  
  return number / 20
end

function GetRandomPosX(width, widgetWidth)
  local result = math.random(0, width)
  if result < 0 then
    result = 0
  elseif widgetWidth and (width - widgetWidth < result) then
    result = width - widgetWidth
  end
  return result
end

function GetRandomPosY(height)
  return math.random(0, height / 4)
end

function CalculateSize(scale, widgetScale)
  return TextWidthMultiplikator * widgetScale * scale + TextMinimumWidth, ((TextSize * scale) * widgetScale) * TextHeightMultiplikator
end

function CreateVisual(panel, posX, posY, value, textformat, textureId, widgetScale, textWidgetMultiplier)
  textWidgetMultiplier = textWidgetMultiplier or 1
  TextMinimumWidth = unit.GetLevel(avatar.GetId())
  local textWidget = GetFreeText()
  local texturePanel = nil
  local scale = GetTextScale(value)
  local targetScale = scale * TextScaleMultiplikator * widgetScale

  -- Positioniere Text
  local placementPlain = textWidget:GetPlacementPlain()
  placementPlain.posX = posX
  placementPlain.posY = posY
  placementPlain.sizeX, placementPlain.sizeY = CalculateSize(scale, widgetScale)
  placementPlain.sizeX = placementPlain.sizeX * textWidgetMultiplier
  textWidget:SetPlacementPlain(placementPlain)
  textWidget:SetAlignY(1)

  panel:AddChild(textWidget)

  -- Erstelle Rechteck fr Text
  --local rectWidget = GetFreeTexture(textureId)
  --rectWidget:SetPlacementPlain(placementPlain)
  --panel:AddChild(rectWidget)
  --rectWidget:PlayFadeEffect(1.0, 0.0, 2500, EA_MONOTONOUS_INCREASE)
  
  

  if textureId then
    -- Erstelle Texture
    texturePanel = GetFreeTexture(textureId)
	texturePanel:SetPriority(100)	

	-- Positioniere Texture
	local tp = texturePanel:GetPlacementPlain()
	tp.sizeX = TextureWidth * widgetScale
	tp.sizeY = TextureHeight * widgetScale
	tp.posX = posX + (placementPlain.sizeX / 2) - (tp.sizeX / 2)
	tp.posY = posY + (placementPlain.sizeY / 2) + (tp.sizeY / 2) 
	texturePanel:SetPlacementPlain(tp)

	-- Bewegungsanimation
	local movementPlain = CopyTable(tp)
	tp.posY = posY + (placementPlain.sizeY / 2) - (tp.sizeY / 2) 
	texturePanel:PlayMoveEffect(tp, movementPlain, 650, EA_MONOTONOUS_INCREASE)
	
	panel:AddChild(texturePanel)

	-- Fadeanimation
	texturePanel:PlayFadeEffect(1.0, 0.0, 1500, EA_MONOTONOUS_INCREASE)	
  end  

  -- Setze Text
  textWidget:SetFormat(textformat)
  textWidget:SetVal("text", common.FormatInt(value, TextValueFormat))

  -- Textanimationen
  local duration = math.ceil((GetDuration(value) * 3 + TextFadeDurationStart) * TextFadeDurationMultiplikator)
  duration = (duration > TextFadeDurationMaximum) and TextFadeDurationMaximum or duration 
  
  local scaleDuration = math.ceil(2000 / scale)
  textWidget:PlayFadeEffect(1.0, 0.0, duration, EA_MONOTONOUS_INCREASE)
  textWidget:PlayTextScaleEffect(0.0, targetScale, scaleDuration, EA_MONOTONOUS_INCREASE)

  -- Gebe beide Widgets zurck
  return textWidget, texturePanel
end
--------------------------------------------------------------------------------
--- EVENTS
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--- REACTIONS
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
--- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
  
end

CallWhenCharacterAvailable(Init)